/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.email;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.email.boundary.AbstractEmailSearchParameters;
import de.ivu.elect.business.email.boundary.EmailChangeEvent;
import de.ivu.elect.business.email.boundary.EmailConversationStore;
import de.ivu.elect.business.email.boundary.EmailExtendedDAO;
import de.ivu.elect.business.email.boundary.EmailSearch;
import de.ivu.elect.business.email.boundary.EmailSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.email.entity.Email;
import de.ivu.elect.business.email.entity.EmailMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractEmailSearchView.COMPONENT_NAME)
@View(viewId = AbstractEmailSearchView.VIEW_ID, useCase = UseCasePermission.EMAIL_SEARCH)
public abstract class AbstractEmailSearchView extends AbstractElectSearchView<Email> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailSearchView";
  
  public static final String VIEW_ID = "/email/email-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractEmailSearchView requestHandler;

  @Inject
  private transient EmailExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(EmailConversationStore.class)
  protected transient EmailConversationStore conversationStore;

  @Inject
  protected transient EmailSearch search;

  @Inject
  @ConversationGroup(AbstractEmailSearchParameters.class)
  protected transient EmailSearchParameters searchParameters;

  @Inject
  protected transient EmailMeta entityMeta;

  public AbstractEmailSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Email getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Email entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public EmailSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Email> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Email> create();
  }

  @Override
  public List<Email> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Email> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onEmailChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) EmailChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractEmailSearchView {

    @View
    @Inject
    private transient Instance<AbstractEmailSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractEmailSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
